Merge tag 'objtool-core-2026-04-13' of git://git.kernel.org/pub/scm/linux/kernel/git/tip/tip

Pull objtool updates from Ingo Molnar:

 - KLP support updates and fixes (Song Liu)

 - KLP-build script updates and fixes (Joe Lawrence)

 - Support Clang RAX DRAP sequence, to address clang false positive
   (Josh Poimboeuf)

 - Reorder ORC register numbering to match regular x86 register
   numbering (Josh Poimboeuf)

 - Misc cleanups (Wentong Tian, Song Liu)

* tag 'objtool-core-2026-04-13' of git://git.kernel.org/pub/scm/linux/kernel/git/tip/tip:
  objtool/x86: Reorder ORC register numbering
  objtool: Support Clang RAX DRAP sequence
  livepatch/klp-build: report patch validation fuzz
  livepatch/klp-build: add terminal color output
  livepatch/klp-build: provide friendlier error messages
  livepatch/klp-build: improve short-circuit validation
  livepatch/klp-build: fix shellcheck complaints
  livepatch/klp-build: add Makefile with check target
  livepatch/klp-build: add grep-override function
  livepatch/klp-build: switch to GNU patch and recountdiff
  livepatch/klp-build: support patches that add/remove files
  objtool/klp: Correlate locals to globals
  objtool/klp: Match symbols based on demangled_name for global variables
  objtool/klp: Remove .llvm suffix in demangle_name()
  objtool/klp: Also demangle global objects
  objtool/klp: Use sym->demangled_name for symbol_name hash
  objtool/klp: Remove trailing '_' in demangle_name()
  objtool/klp: Remove redundant strcmp() in correlate_symbols()
  objtool: Use section/symbol type helpers
This commit is contained in:
Linus Torvalds
2026-04-14 13:00:04 -07:00
12 changed files with 337 additions and 126 deletions

View File

@@ -28,15 +28,16 @@
* and GCC realigned stacks.
*/
#define ORC_REG_UNDEFINED 0
#define ORC_REG_PREV_SP 1
#define ORC_REG_AX 1
#define ORC_REG_DX 2
#define ORC_REG_DI 3
#define ORC_REG_SP 3
#define ORC_REG_BP 4
#define ORC_REG_SP 5
#define ORC_REG_DI 5
#define ORC_REG_R10 6
#define ORC_REG_R13 7
#define ORC_REG_BP_INDIRECT 8
#define ORC_REG_PREV_SP 8
#define ORC_REG_SP_INDIRECT 9
#define ORC_REG_BP_INDIRECT 10
#define ORC_REG_MAX 15
#define ORC_TYPE_UNDEFINED 0

View File

@@ -546,17 +546,23 @@ bool unwind_next_frame(struct unwind_state *state)
indirect = true;
break;
case ORC_REG_R10:
if (!get_reg(state, offsetof(struct pt_regs, r10), &sp)) {
orc_warn_current("missing R10 value at %pB\n",
/*
* Any of the below registers may temporarily hold the stack pointer,
* typically during a DRAP stack realignment sequence or some other
* stack swizzle.
*/
case ORC_REG_AX:
if (!get_reg(state, offsetof(struct pt_regs, ax), &sp)) {
orc_warn_current("missing AX value at %pB\n",
(void *)state->ip);
goto err;
}
break;
case ORC_REG_R13:
if (!get_reg(state, offsetof(struct pt_regs, r13), &sp)) {
orc_warn_current("missing R13 value at %pB\n",
case ORC_REG_DX:
if (!get_reg(state, offsetof(struct pt_regs, dx), &sp)) {
orc_warn_current("missing DX value at %pB\n",
(void *)state->ip);
goto err;
}
@@ -570,9 +576,17 @@ bool unwind_next_frame(struct unwind_state *state)
}
break;
case ORC_REG_DX:
if (!get_reg(state, offsetof(struct pt_regs, dx), &sp)) {
orc_warn_current("missing DX value at %pB\n",
case ORC_REG_R10:
if (!get_reg(state, offsetof(struct pt_regs, r10), &sp)) {
orc_warn_current("missing R10 value at %pB\n",
(void *)state->ip);
goto err;
}
break;
case ORC_REG_R13:
if (!get_reg(state, offsetof(struct pt_regs, r13), &sp)) {
orc_warn_current("missing R13 value at %pB\n",
(void *)state->ip);
goto err;
}

View File

@@ -0,0 +1,20 @@
# SPDX-License-Identifier: GPL-2.0
# Standalone Makefile for developer tooling (not part of kbuild).
SHELLCHECK := $(shell which shellcheck 2> /dev/null)
SRCS := \
klp-build
.DEFAULT_GOAL := help
.PHONY: help
help:
@echo " check - Run shellcheck on $(SRCS)"
@echo " help - Show this help message"
.PHONY: check
check:
ifndef SHELLCHECK
$(error shellcheck is not installed. Please install it to run checks)
endif
@$(SHELLCHECK) $(SHELLCHECK_OPTIONS) $(SRCS)

View File

@@ -52,20 +52,37 @@ PATCH_TMP_DIR="$TMP_DIR/tmp"
KLP_DIFF_LOG="$DIFF_DIR/diff.log"
# Terminal output colors
read -r COLOR_RESET COLOR_BOLD COLOR_ERROR COLOR_WARN <<< ""
if [[ -t 1 && -t 2 ]]; then
COLOR_RESET="\033[0m"
COLOR_BOLD="\033[1m"
COLOR_ERROR="\033[0;31m"
COLOR_WARN="\033[0;33m"
fi
grep0() {
# shellcheck disable=SC2317
command grep "$@" || true
}
# Because pipefail is enabled, the grep0 helper should be used instead of
# grep, otherwise a failed match can propagate to an error.
grep() {
echo "error: $SCRIPT: use grep0 or 'command grep' instead of bare grep" >&2
exit 1
}
status() {
echo "$*"
echo -e "${COLOR_BOLD}$*${COLOR_RESET}"
}
warn() {
echo "error: $SCRIPT: $*" >&2
echo -e "${COLOR_WARN}warning${COLOR_RESET}: $SCRIPT: $*" >&2
}
die() {
warn "$@"
echo -e "${COLOR_ERROR}error${COLOR_RESET}: $SCRIPT: $*" >&2
exit 1
}
@@ -95,14 +112,14 @@ restore_files() {
cleanup() {
set +o nounset
revert_patches "--recount"
revert_patches
restore_files
[[ "$KEEP_TMP" -eq 0 ]] && rm -rf "$TMP_DIR"
return 0
}
trap_err() {
warn "line ${BASH_LINENO[0]}: '$BASH_COMMAND'"
die "line ${BASH_LINENO[0]}: '$BASH_COMMAND'"
}
trap cleanup EXIT INT TERM HUP
@@ -212,7 +229,7 @@ process_args() {
esac
done
if [[ $# -eq 0 ]]; then
if [[ $# -eq 0 ]] && (( SHORT_CIRCUIT <= 2 )); then
usage
exit 1
fi
@@ -282,7 +299,7 @@ set_module_name() {
}
# Hardcode the value printed by the localversion script to prevent patch
# application from appending it with '+' due to a dirty git working tree.
# application from appending it with '+' due to a dirty working tree.
set_kernelversion() {
local file="$SRC/scripts/setlocalversion"
local kernelrelease
@@ -295,28 +312,31 @@ set_kernelversion() {
sed -i "2i echo $kernelrelease; exit 0" scripts/setlocalversion
}
get_patch_files() {
get_patch_input_files() {
local patch="$1"
grep0 -E '^(--- |\+\+\+ )' "$patch" \
grep0 -E '^--- ' "$patch" \
| grep0 -v -e '/dev/null' -e '1969-12-31' -e '1970-01-01' \
| gawk '{print $2}' \
| sed 's|^[^/]*/||' \
| sort -u
}
# Make sure git re-stats the changed files
git_refresh() {
get_patch_output_files() {
local patch="$1"
local files=()
[[ ! -e "$SRC/.git" ]] && return
grep0 -E '^\+\+\+ ' "$patch" \
| grep0 -v -e '/dev/null' -e '1969-12-31' -e '1970-01-01' \
| gawk '{print $2}' \
| sed 's|^[^/]*/||' \
| sort -u
}
get_patch_files "$patch" | mapfile -t files
get_patch_files() {
local patch="$1"
(
cd "$SRC"
git update-index -q --refresh -- "${files[@]}"
)
{ get_patch_input_files "$patch"; get_patch_output_files "$patch"; } \
| sort -u
}
check_unsupported_patches() {
@@ -330,7 +350,7 @@ check_unsupported_patches() {
for file in "${files[@]}"; do
case "$file" in
lib/*|*.S)
die "unsupported patch to $file"
die "${patch}: unsupported patch to $file"
;;
esac
done
@@ -341,34 +361,30 @@ apply_patch() {
local patch="$1"
shift
local extra_args=("$@")
local drift_regex="with fuzz|offset [0-9]+ line"
local output
local status
[[ ! -f "$patch" ]] && die "$patch doesn't exist"
status=0
output=$(patch -d "$SRC" -p1 --dry-run --no-backup-if-mismatch -r /dev/null "${extra_args[@]}" < "$patch" 2>&1) || status=$?
if [[ "$status" -ne 0 ]]; then
echo "$output" >&2
die "$patch did not apply"
elif [[ "$output" =~ $drift_regex ]]; then
echo "$output" >&2
warn "${patch} applied with fuzz"
fi
(
cd "$SRC"
# The sed strips the version signature from 'git format-patch',
# otherwise 'git apply --recount' warns.
sed -n '/^-- /q;p' "$patch" |
git apply "${extra_args[@]}"
)
patch -d "$SRC" -p1 --no-backup-if-mismatch -r /dev/null "${extra_args[@]}" --silent < "$patch"
APPLIED_PATCHES+=("$patch")
}
revert_patch() {
local patch="$1"
shift
local extra_args=("$@")
local tmp=()
(
cd "$SRC"
sed -n '/^-- /q;p' "$patch" |
git apply --reverse "${extra_args[@]}"
)
git_refresh "$patch"
patch -d "$SRC" -p1 -R --silent --no-backup-if-mismatch -r /dev/null < "$patch"
for p in "${APPLIED_PATCHES[@]}"; do
[[ "$p" == "$patch" ]] && continue
@@ -379,19 +395,19 @@ revert_patch() {
}
apply_patches() {
local extra_args=("$@")
local patch
for patch in "${PATCHES[@]}"; do
apply_patch "$patch"
apply_patch "$patch" "${extra_args[@]}"
done
}
revert_patches() {
local extra_args=("$@")
local patches=("${APPLIED_PATCHES[@]}")
for (( i=${#patches[@]}-1 ; i>=0 ; i-- )) ; do
revert_patch "${patches[$i]}" "${extra_args[@]}"
revert_patch "${patches[$i]}"
done
APPLIED_PATCHES=()
@@ -415,6 +431,7 @@ do_init() {
APPLIED_PATCHES=()
[[ -x "$FIX_PATCH_LINES" ]] || die "can't find fix-patch-lines"
command -v recountdiff &>/dev/null || die "recountdiff not found (install patchutils)"
validate_config
set_module_name
@@ -425,25 +442,27 @@ do_init() {
refresh_patch() {
local patch="$1"
local tmpdir="$PATCH_TMP_DIR"
local files=()
local input_files=()
local output_files=()
rm -rf "$tmpdir"
mkdir -p "$tmpdir/a"
mkdir -p "$tmpdir/b"
# Get all source files affected by the patch
get_patch_files "$patch" | mapfile -t files
get_patch_input_files "$patch" | mapfile -t input_files
get_patch_output_files "$patch" | mapfile -t output_files
# Copy orig source files to 'a'
( cd "$SRC" && echo "${files[@]}" | xargs cp --parents --target-directory="$tmpdir/a" )
( cd "$SRC" && echo "${input_files[@]}" | xargs cp --parents --target-directory="$tmpdir/a" )
# Copy patched source files to 'b'
apply_patch "$patch" --recount
( cd "$SRC" && echo "${files[@]}" | xargs cp --parents --target-directory="$tmpdir/b" )
revert_patch "$patch" --recount
apply_patch "$patch" "--silent"
( cd "$SRC" && echo "${output_files[@]}" | xargs cp --parents --target-directory="$tmpdir/b" )
revert_patch "$patch"
# Diff 'a' and 'b' to make a clean patch
( cd "$tmpdir" && git diff --no-index --no-prefix a b > "$patch" ) || true
( cd "$tmpdir" && diff -Nupr a b > "$patch" ) || true
}
# Copy the patches to a temporary directory, fix their lines so as not to
@@ -466,8 +485,7 @@ fix_patches() {
cp -f "$old_patch" "$tmp_patch"
refresh_patch "$tmp_patch"
"$FIX_PATCH_LINES" "$tmp_patch" > "$new_patch"
refresh_patch "$new_patch"
"$FIX_PATCH_LINES" "$tmp_patch" | recountdiff > "$new_patch"
PATCHES[i]="$new_patch"
@@ -491,6 +509,7 @@ clean_kernel() {
}
build_kernel() {
local build="$1"
local log="$TMP_DIR/build.log"
local objtool_args=()
local cmd=()
@@ -528,7 +547,7 @@ build_kernel() {
"${cmd[@]}" \
1> >(tee -a "$log") \
2> >(tee -a "$log" | grep0 -v "modpost.*undefined!" >&2)
)
) || die "$build kernel build failed"
}
find_objects() {
@@ -555,7 +574,6 @@ copy_orig_objects() {
for _file in "${files[@]}"; do
local rel_file="${_file/.ko/.o}"
local file="$OBJ/$rel_file"
local file_dir="$(dirname "$file")"
local orig_file="$ORIG_DIR/$rel_file"
local orig_dir="$(dirname "$orig_file")"
@@ -796,12 +814,15 @@ build_patch_module() {
process_args "$@"
do_init
if (( SHORT_CIRCUIT <= 1 )); then
if (( SHORT_CIRCUIT <= 2 )); then
status "Validating patch(es)"
validate_patches
fi
if (( SHORT_CIRCUIT <= 1 )); then
status "Building original kernel"
clean_kernel
build_kernel
build_kernel "original"
status "Copying original object files"
copy_orig_objects
fi
@@ -809,9 +830,9 @@ fi
if (( SHORT_CIRCUIT <= 2 )); then
status "Fixing patch(es)"
fix_patches
apply_patches
apply_patches "--silent"
status "Building patched kernel"
build_kernel
build_kernel "patched"
revert_patches
status "Copying patched object files"
copy_patched_objects

View File

@@ -28,15 +28,16 @@
* and GCC realigned stacks.
*/
#define ORC_REG_UNDEFINED 0
#define ORC_REG_PREV_SP 1
#define ORC_REG_AX 1
#define ORC_REG_DX 2
#define ORC_REG_DI 3
#define ORC_REG_SP 3
#define ORC_REG_BP 4
#define ORC_REG_SP 5
#define ORC_REG_DI 5
#define ORC_REG_R10 6
#define ORC_REG_R13 7
#define ORC_REG_BP_INDIRECT 8
#define ORC_REG_PREV_SP 8
#define ORC_REG_SP_INDIRECT 9
#define ORC_REG_BP_INDIRECT 10
#define ORC_REG_MAX 15
#define ORC_TYPE_UNDEFINED 0

View File

@@ -875,14 +875,20 @@ int arch_decode_hint_reg(u8 sp_reg, int *base)
case ORC_REG_UNDEFINED:
*base = CFI_UNDEFINED;
break;
case ORC_REG_AX:
*base = CFI_AX;
break;
case ORC_REG_DX:
*base = CFI_DX;
break;
case ORC_REG_SP:
*base = CFI_SP;
break;
case ORC_REG_BP:
*base = CFI_BP;
break;
case ORC_REG_SP_INDIRECT:
*base = CFI_SP_INDIRECT;
case ORC_REG_DI:
*base = CFI_DI;
break;
case ORC_REG_R10:
*base = CFI_R10;
@@ -890,11 +896,11 @@ int arch_decode_hint_reg(u8 sp_reg, int *base)
case ORC_REG_R13:
*base = CFI_R13;
break;
case ORC_REG_DI:
*base = CFI_DI;
case ORC_REG_SP_INDIRECT:
*base = CFI_SP_INDIRECT;
break;
case ORC_REG_DX:
*base = CFI_DX;
case ORC_REG_BP_INDIRECT:
*base = CFI_BP_INDIRECT;
break;
default:
return -1;

View File

@@ -46,17 +46,20 @@ int init_orc_entry(struct orc_entry *orc, struct cfi_state *cfi, struct instruct
orc->signal = cfi->signal;
switch (cfi->cfa.base) {
case CFI_AX:
orc->sp_reg = ORC_REG_AX;
break;
case CFI_DX:
orc->sp_reg = ORC_REG_DX;
break;
case CFI_SP:
orc->sp_reg = ORC_REG_SP;
break;
case CFI_SP_INDIRECT:
orc->sp_reg = ORC_REG_SP_INDIRECT;
break;
case CFI_BP:
orc->sp_reg = ORC_REG_BP;
break;
case CFI_BP_INDIRECT:
orc->sp_reg = ORC_REG_BP_INDIRECT;
case CFI_DI:
orc->sp_reg = ORC_REG_DI;
break;
case CFI_R10:
orc->sp_reg = ORC_REG_R10;
@@ -64,11 +67,11 @@ int init_orc_entry(struct orc_entry *orc, struct cfi_state *cfi, struct instruct
case CFI_R13:
orc->sp_reg = ORC_REG_R13;
break;
case CFI_DI:
orc->sp_reg = ORC_REG_DI;
case CFI_SP_INDIRECT:
orc->sp_reg = ORC_REG_SP_INDIRECT;
break;
case CFI_DX:
orc->sp_reg = ORC_REG_DX;
case CFI_BP_INDIRECT:
orc->sp_reg = ORC_REG_BP_INDIRECT;
break;
default:
ERROR_INSN(insn, "unknown CFA base reg %d", cfi->cfa.base);
@@ -122,22 +125,24 @@ static const char *reg_name(unsigned int reg)
switch (reg) {
case ORC_REG_PREV_SP:
return "prevsp";
case ORC_REG_AX:
return "ax";
case ORC_REG_DX:
return "dx";
case ORC_REG_DI:
return "di";
case ORC_REG_BP:
return "bp";
case ORC_REG_SP:
return "sp";
case ORC_REG_DI:
return "di";
case ORC_REG_R10:
return "r10";
case ORC_REG_R13:
return "r13";
case ORC_REG_BP_INDIRECT:
return "bp(ind)";
case ORC_REG_SP_INDIRECT:
return "sp(ind)";
case ORC_REG_BP_INDIRECT:
return "bp(ind)";
default:
return "?";
}

View File

@@ -4306,8 +4306,8 @@ static int validate_retpoline(struct objtool_file *file)
list_for_each_entry(insn, &file->retpoline_call_list, call_node) {
struct symbol *sym = insn->sym;
if (sym && (sym->type == STT_NOTYPE ||
sym->type == STT_FUNC) && !sym->nocfi) {
if (sym && (is_notype_sym(sym) ||
is_func_sym(sym)) && !sym->nocfi) {
struct instruction *prev =
prev_insn_same_sym(file, insn);

View File

@@ -264,7 +264,7 @@ static void disas_print_addr_reloc(bfd_vma addr, struct disassemble_info *dinfo)
* If the relocation symbol is a section name (for example ".bss")
* then we try to further resolve the name.
*/
if (reloc->sym->type == STT_SECTION) {
if (is_sec_sym(reloc->sym)) {
str = offstr(reloc->sym->sec, reloc->sym->offset + offset);
DINFO_FPRINTF(dinfo, bfd_vma_fmt, addr, str);
free(str);
@@ -580,7 +580,7 @@ static size_t disas_insn_common(struct disas_context *dctx,
*/
dinfo->buffer = insn->sec->data->d_buf;
dinfo->buffer_vma = 0;
dinfo->buffer_length = insn->sec->sh.sh_size;
dinfo->buffer_length = sec_size(insn->sec);
return disasm(insn->offset, &dctx->info);
}
@@ -1231,7 +1231,7 @@ void disas_funcs(struct disas_context *dctx)
for_each_sec(dctx->file->elf, sec) {
if (!(sec->sh.sh_flags & SHF_EXECINSTR))
if (!is_text_sec(sec))
continue;
sec_for_each_sym(sec, sym) {

View File

@@ -25,11 +25,18 @@
#include <objtool/elf.h>
#include <objtool/warn.h>
static ssize_t demangled_name_len(const char *name);
static inline u32 str_hash(const char *str)
{
return jhash(str, strlen(str), 0);
}
static inline u32 str_hash_demangled(const char *str)
{
return jhash(str, demangled_name_len(str), 0);
}
#define __elf_table(name) (elf->name##_hash)
#define __elf_bits(name) (elf->name##_bits)
@@ -293,7 +300,7 @@ static struct symbol *find_local_symbol_by_file_and_name(const struct elf *elf,
{
struct symbol *sym;
elf_hash_for_each_possible(symbol_name, sym, name_hash, str_hash(name)) {
elf_hash_for_each_possible(symbol_name, sym, name_hash, str_hash_demangled(name)) {
if (sym->bind == STB_LOCAL && sym->file == file &&
!strcmp(sym->name, name)) {
return sym;
@@ -307,7 +314,7 @@ struct symbol *find_global_symbol_by_name(const struct elf *elf, const char *nam
{
struct symbol *sym;
elf_hash_for_each_possible(symbol_name, sym, name_hash, str_hash(name)) {
elf_hash_for_each_possible(symbol_name, sym, name_hash, str_hash_demangled(name)) {
if (!strcmp(sym->name, name) && !is_local_sym(sym))
return sym;
}
@@ -315,6 +322,19 @@ struct symbol *find_global_symbol_by_name(const struct elf *elf, const char *nam
return NULL;
}
void iterate_global_symbol_by_demangled_name(const struct elf *elf,
const char *demangled_name,
void (*process)(struct symbol *sym, void *data),
void *data)
{
struct symbol *sym;
elf_hash_for_each_possible(symbol_name, sym, name_hash, str_hash(demangled_name)) {
if (!strcmp(sym->demangled_name, demangled_name) && !is_local_sym(sym))
process(sym, data);
}
}
struct reloc *find_reloc_by_dest_range(const struct elf *elf, struct section *sec,
unsigned long offset, unsigned int len)
{
@@ -440,34 +460,67 @@ static int read_sections(struct elf *elf)
return 0;
}
/*
* Returns desired length of the demangled name.
* If name doesn't need demangling, return strlen(name).
*/
static ssize_t demangled_name_len(const char *name)
{
ssize_t idx;
const char *p;
p = strstr(name, ".llvm.");
if (p)
return p - name;
if (!strstarts(name, "__UNIQUE_ID_") && !strchr(name, '.'))
return strlen(name);
for (idx = strlen(name) - 1; idx >= 0; idx--) {
char c = name[idx];
if (!isdigit(c) && c != '.' && c != '_')
break;
}
if (idx <= 0)
return strlen(name);
return idx + 1;
}
/*
* Remove number suffix of a symbol.
*
* Specifically, remove trailing numbers for "__UNIQUE_ID_" symbols and
* symbols with '.'.
*
* With CONFIG_LTO_CLANG_THIN, it is possible to have nested __UNIQUE_ID_,
* such as
*
* __UNIQUE_ID_addressable___UNIQUE_ID_pci_invalid_bar_694_695
*
* to remove both trailing numbers, also remove trailing '_'.
*
* For symbols with llvm suffix, i.e., foo.llvm.<hash>, remove the
* .llvm.<hash> part.
*/
static const char *demangle_name(struct symbol *sym)
{
char *str;
if (!is_local_sym(sym))
return sym->name;
ssize_t len;
if (!is_func_sym(sym) && !is_object_sym(sym))
return sym->name;
if (!strstarts(sym->name, "__UNIQUE_ID_") && !strchr(sym->name, '.'))
len = demangled_name_len(sym->name);
if (len == strlen(sym->name))
return sym->name;
str = strdup(sym->name);
str = strndup(sym->name, len);
if (!str) {
ERROR_GLIBC("strdup");
return NULL;
}
for (int i = strlen(str) - 1; i >= 0; i--) {
char c = str[i];
if (!isdigit(c) && c != '.') {
str[i + 1] = '\0';
break;
}
}
return str;
}
@@ -503,9 +556,13 @@ static int elf_add_symbol(struct elf *elf, struct symbol *sym)
entry = &sym->sec->symbol_list;
list_add(&sym->list, entry);
sym->demangled_name = demangle_name(sym);
if (!sym->demangled_name)
return -1;
list_add_tail(&sym->global_list, &elf->symbols);
elf_hash_add(symbol, &sym->hash, sym->idx);
elf_hash_add(symbol_name, &sym->name_hash, str_hash(sym->name));
elf_hash_add(symbol_name, &sym->name_hash, str_hash(sym->demangled_name));
if (is_func_sym(sym) &&
(strstarts(sym->name, "__pfx_") ||
@@ -529,10 +586,6 @@ static int elf_add_symbol(struct elf *elf, struct symbol *sym)
sym->pfunc = sym->cfunc = sym;
sym->demangled_name = demangle_name(sym);
if (!sym->demangled_name)
return -1;
return 0;
}
@@ -613,7 +666,7 @@ static int read_symbols(struct elf *elf)
if (elf_add_symbol(elf, sym))
return -1;
if (sym->type == STT_FILE)
if (is_file_sym(sym))
file = sym;
else if (sym->bind == STB_LOCAL)
sym->file = file;
@@ -1318,7 +1371,7 @@ unsigned int elf_add_string(struct elf *elf, struct section *strtab, const char
return -1;
}
offset = ALIGN(strtab->sh.sh_size, strtab->sh.sh_addralign);
offset = ALIGN(sec_size(strtab), strtab->sh.sh_addralign);
if (!elf_add_data(elf, strtab, str, strlen(str) + 1))
return -1;
@@ -1360,7 +1413,7 @@ void *elf_add_data(struct elf *elf, struct section *sec, const void *data, size_
sec->data->d_size = size;
sec->data->d_align = sec->sh.sh_addralign;
offset = ALIGN(sec->sh.sh_size, sec->sh.sh_addralign);
offset = ALIGN(sec_size(sec), sec->sh.sh_addralign);
sec->sh.sh_size = offset + size;
mark_sec_changed(elf, sec, true);

View File

@@ -186,6 +186,9 @@ struct symbol *find_func_by_offset(struct section *sec, unsigned long offset);
struct symbol *find_symbol_by_offset(struct section *sec, unsigned long offset);
struct symbol *find_symbol_by_name(const struct elf *elf, const char *name);
struct symbol *find_global_symbol_by_name(const struct elf *elf, const char *name);
void iterate_global_symbol_by_demangled_name(const struct elf *elf, const char *demangled_name,
void (*process)(struct symbol *sym, void *data),
void *data);
struct symbol *find_symbol_containing(const struct section *sec, unsigned long offset);
int find_symbol_hole_containing(const struct section *sec, unsigned long offset);
struct reloc *find_reloc_by_dest(const struct elf *elf, struct section *sec, unsigned long offset);

View File

@@ -272,7 +272,7 @@ static bool is_uncorrelated_static_local(struct symbol *sym)
*/
static bool is_clang_tmp_label(struct symbol *sym)
{
return sym->type == STT_NOTYPE &&
return is_notype_sym(sym) &&
is_text_sec(sym->sec) &&
strstarts(sym->name, ".Ltmp") &&
isdigit(sym->name[5]);
@@ -356,6 +356,46 @@ static bool dont_correlate(struct symbol *sym)
strstarts(sym->name, "__initcall__");
}
struct process_demangled_name_data {
struct symbol *ret;
int count;
};
static void process_demangled_name(struct symbol *sym, void *d)
{
struct process_demangled_name_data *data = d;
if (sym->twin)
return;
data->count++;
data->ret = sym;
}
/*
* When there is no full name match, try match demangled_name. This would
* match original foo.llvm.123 to patched foo.llvm.456.
*
* Note that, in very rare cases, it is possible to have multiple
* foo.llvm.<hash> in the same kernel. When this happens, report error and
* fail the diff.
*/
static int find_global_symbol_by_demangled_name(struct elf *elf, struct symbol *sym,
struct symbol **out_sym)
{
struct process_demangled_name_data data = {};
iterate_global_symbol_by_demangled_name(elf, sym->demangled_name,
process_demangled_name,
&data);
if (data.count > 1) {
ERROR("Multiple (%d) correlation candidates for %s", data.count, sym->name);
return -1;
}
*out_sym = data.ret;
return 0;
}
/*
* For each symbol in the original kernel, find its corresponding "twin" in the
* patched kernel.
@@ -454,13 +494,60 @@ static int correlate_symbols(struct elfs *e)
continue;
sym2 = find_global_symbol_by_name(e->patched, sym1->name);
if (sym2 && !sym2->twin && !strcmp(sym1->name, sym2->name)) {
if (sym2 && !sym2->twin) {
sym1->twin = sym2;
sym2->twin = sym1;
}
}
/*
* Correlate globals with demangled_name.
* A separate loop is needed because we want to finish all the
* full name correlations first.
*/
for_each_sym(e->orig, sym1) {
if (sym1->bind == STB_LOCAL || sym1->twin)
continue;
if (find_global_symbol_by_demangled_name(e->patched, sym1, &sym2))
return -1;
if (sym2 && !sym2->twin) {
sym1->twin = sym2;
sym2->twin = sym1;
}
}
/* Correlate original locals with patched globals */
for_each_sym(e->orig, sym1) {
if (sym1->twin || dont_correlate(sym1) || !is_local_sym(sym1))
continue;
sym2 = find_global_symbol_by_name(e->patched, sym1->name);
if (!sym2 && find_global_symbol_by_demangled_name(e->patched, sym1, &sym2))
return -1;
if (sym2 && !sym2->twin) {
sym1->twin = sym2;
sym2->twin = sym1;
}
}
/* Correlate original globals with patched locals */
for_each_sym(e->patched, sym2) {
if (sym2->twin || dont_correlate(sym2) || !is_local_sym(sym2))
continue;
sym1 = find_global_symbol_by_name(e->orig, sym2->name);
if (!sym1 && find_global_symbol_by_demangled_name(e->orig, sym2, &sym1))
return -1;
if (sym1 && !sym1->twin) {
sym2->twin = sym1;
sym1->twin = sym2;
}
}
for_each_sym(e->orig, sym1) {
if (sym1->twin || dont_correlate(sym1))
continue;
@@ -481,7 +568,7 @@ static unsigned long find_sympos(struct elf *elf, struct symbol *sym)
if (sym->bind != STB_LOCAL)
return 0;
if (vmlinux && sym->type == STT_FUNC) {
if (vmlinux && is_func_sym(sym)) {
/*
* HACK: Unfortunately, symbol ordering can differ between
* vmlinux.o and vmlinux due to the linker script emitting
@@ -1047,8 +1134,8 @@ static int clone_reloc_klp(struct elfs *e, struct reloc *patched_reloc,
sec->name, offset, patched_sym->name, \
addend >= 0 ? "+" : "-", labs(addend), \
sym_type(patched_sym), \
patched_sym->type == STT_SECTION ? "" : " ", \
patched_sym->type == STT_SECTION ? "" : sym_bind(patched_sym), \
is_sec_sym(patched_sym) ? "" : " ", \
is_sec_sym(patched_sym) ? "" : sym_bind(patched_sym), \
is_undef_sym(patched_sym) ? " UNDEF" : "", \
export ? " EXPORTED" : "", \
klp ? " KLP" : "")